do
--local VeterancyHelper = import('/mods/TotalVeterancy/helper/VeterancyHelper.lua')
    local oldModBP = ModBlueprints

    function ModBlueprints(all_bps)
        oldModBP(all_bps)

        --parameters for customisation
        local scaling = 0.5 --(square root)
        local evenkills = 1 -- was 4--adjusted xp gained by *0.25

        --base values calculated from cost to compare
        --gh, no longer accurate
        --t1(Mantis)=144,3
        --t2(Rhino)= 517
        --t3(Loyalist)=1620 (Trebuchet)=2800 (Brick)=3880 (Summoner)=6750
        --t4(Monkeylord)=39000 (Ylotha)=48750 (GC)=54843,75 (Fatboy)=59962,5 (Megalith)=77343,75
        --t4(Paragon)=1032075
        local ACUbaseValue = 1600  --
        local SCUbaseValue = 6400  -- 21k if calculated by cost
        --local MonkeylordValue =
        --local MegalithValue =
        --local SoulripperValue =
        --local GCValue =
        --local CzarValue =
        --local FatboyValue =
        --local YlothaValue =
        --local AhwassaValue =


        --dropdown code for lobby not working

        --gh, it may work with a support scd file or a map which sets the option
        --not sure if former will play nice in mp games

        --if ScenarioInfo.Options.XPFormular == "3/4" then
        --    LOG('is set')
        --else
        --    LOG('not set')
        --end



        local once = true
        for id,bp in all_bps.Unit do

            if bp.Weapon then
--    local numWeapons = table.getn(bp.Weapon)
                --gh, this disables friendly fire, does not work for nukes though
                for k,v in bp.Weapon do
                    if v.Label != 'DeathWeapon' then
                        v.DamageFriendly = false
                        v.CollideFriendly = false
                    end
                end
            end



            if bp.Economy.BuildRate > 4 then  -- gh, fixes missing blueprint value
                if not bp.Economy.MaxBuildDistance then
                    bp.Economy.MaxBuildDistance = 10
                end
            end--gh, and sets build range a bit higher than we are used to


            if bp.Defense.RegenRate == nil then
                bp.Defense.RegenRate = 0
            end
            local RegenMod = 0.9*(50 - 1 / (0.00000060257 * bp.Defense.MaxHealth + 0.020016))
            bp.Defense.RegenRate = bp.Defense.RegenRate + RegenMod

            -- Override for ACUs and SCUs
            if bp.Economy and not bp.Economy.xpBaseValue and bp.Economy.BuildCostMass and bp.Economy.BuildCostEnergy and bp.Economy.BuildTime and table.find(bp.Categories,'COMMAND') then
                bp.Economy.xpBaseValue = ACUbaseValue
            end--acu
            if bp.Economy and not bp.Economy.xpBaseValue and bp.Economy.BuildCostMass and bp.Economy.BuildCostEnergy and bp.Economy.BuildTime and table.find(bp.Categories,'SUBCOMMANDER') then
                bp.Economy.xpBaseValue = SCUbaseValue
            end--scu

            --calculate xp depending on xpBaseValue of from cost if no base value is set.
            --old values are not overwritten
            if bp.Economy and not bp.Economy.xpValue and bp.Economy.BuildCostMass and bp.Economy.BuildCostEnergy and bp.Economy.BuildTime and (not table.find(bp.Categories,'UNTARGETABLE') or bp.Economy.xpBaseValue) then
                bp.Economy.xpValue = math.pow((bp.Economy.xpBaseValue or (bp.Economy.BuildCostMass + bp.Economy.BuildCostEnergy*0.1 + bp.Economy.BuildTime*0.04)),scaling)
                --if bp.Description then LOG(bp.Description .. ' ' .. bp.Economy.xpValue) end
            end

            --calculate xp per level depending on own value and kills per level set.
            if bp.Economy and not bp.Economy.XPperLevel and bp.Economy.xpValue then
                bp.Economy.XPperLevel = bp.Economy.xpValue * evenkills
            end
            if bp.Economy and bp.Defense and not bp.Economy.xpPerHp and bp.Economy.xpValue and bp.Defense.MaxHealth then
                bp.Economy.xpPerHp = bp.Economy.xpValue / bp.Defense.MaxHealth
            end

            --gh, AutoXP merge

            --structures which generate resources gain AutoXP
            --MassXP
            if bp.Categories and table.find(bp.Categories,'STRUCTURE') and (table.find(bp.Categories,'MASSEXTRACTION') or  table.find(bp.Categories,'MASSFABRICATION') or table.find(bp.Categories,'MASSPRODUCTION')) and not bp.Economy.xpTimeStep and not table.find(bp.Categories,'UNTARGETABLE') then
                bp.Economy.xpTimeStep = math.random(99,119)
            end
            --PowerplantXP
            if bp.Categories and table.find(bp.Categories,'STRUCTURE') and table.find(bp.Categories,'ENERGYPRODUCTION') and not bp.Economy.xpTimeStep and not table.find(bp.Categories,'UNTARGETABLE') then
                bp.Economy.xpTimeStep = math.random(98,118)
            end

            --StorageXP
            if bp.Categories and (table.find(bp.Categories,'STRUCTURE') and table.find(bp.Categories,'ENERGYSTORAGE') or table.find(bp.Categories,'MASSSTORAGE')) and not bp.Economy.xpTimeStep and not table.find(bp.Categories,'UNTARGETABLE') then
                bp.Economy.xpTimeStep = math.random(94,114)
            end

            -- Intel gains xp
            if bp.Categories and table.find(bp.Categories,'INTELLIGENCE') and (table.find(bp.Categories,'STRUCTURE') or table.find(bp.Categories,'MOBILESONAR')) and not bp.Economy.xpTimeStep and not table.find(bp.Categories,'UNTARGETABLE') then
                bp.Economy.xpTimeStep = math.random(101,121)
            end
            -- Immobile Shields gain xp
            if bp.Categories and table.find(bp.Categories,'STRUCTURE') and table.find(bp.Categories,'SHIELD') and not bp.Economy.xpTimeStep  and not table.find(bp.Categories,'UNTARGETABLE') then
                bp.Economy.xpTimeStep = math.random(100,120)
            end

            --BuildXP
            if bp.Categories and (table.find(bp.Categories,'CONSTRUCTION') or table.find(bp.Categories,'ENGINEER') or table.find(bp.Categories,'FACTORY') or
                table.find(bp.Categories,'SILO') or
                bp.General.UpgradesTo) and not table.find(bp.Categories,'UNTARGETABLE') and not bp.Economy.BuildxpLevelpSecond then
                bp.Economy.BuildXPLevelpSecond = 1--(math.random(24,36))
            end

        end
    end
end
