do
    local originalCreateUI = CreateUI
    function CreateUI(isReplay)
        originalCreateUI(isReplay)
        if isReplay == false then
            local parent = import('/lua/ui/game/borders.lua').GetMapGroup()
            SwapButton(parent)
            if SessionIsMultiplayer() == false then
                BuffButton(parent)
            end
        end
    end
    local Tooltip = import('/lua/ui/game/tooltip.lua')
    local Button = import('/lua/maui/button.lua').Button
    local UIUtil = import('/lua/ui/uiutil.lua')
    function SwapButton(parent)
        local meButton = Button(parent, UIUtil.UIFile('/game/mfd_btn/economy_btn_up.dds'), UIUtil.UIFile('/game/mfd_btn/economy_btn_down.dds'), UIUtil.UIFile('/game/mfd_btn/economy_btn_over.dds'), UIUtil.UIFile('/game/mfd_btn/economy_btn_dis.dds'))
        meButton.Left:Set(function() return parent.Left() + 0 end)
        meButton.Top:Set(function() return parent.Top() + 60 end)
        meButton.OnClick = function()
            SimCallback({Func = 'ToggleMEStorage', Args = {owner = GetFocusArmy()}})
        end
        meButton.Depth:Set(100)
        meButton:EnableHitTest(true)
        meButton:Show()
        Tooltip.AddButtonTooltip(meButton,'ToggleMEStorage',2)
    end
    local buffed = 0
    function BuffButton(parent)
        local bButton = Button(parent, UIUtil.UIFile('/game/mfd_btn/military_btn_up.dds'), UIUtil.UIFile('/game/mfd_btn/military_btn_down.dds'), UIUtil.UIFile('/game/mfd_btn/military_btn_over.dds'), UIUtil.UIFile('/game/mfd_btn/military_btn_dis.dds'))
        bButton.Left:Set(function() return parent.Left() + 40 end)
        bButton.Top:Set(function() return parent.Top() + 60 end)
        bButton.OnClick = function()
            SimCallback({Func = 'BuffAIs', Args = {owner = GetFocusArmy()}})
            buffed = buffed + 1
            print('Increased AI Levels by ' .. buffed ..'!')
        end
        bButton.Depth:Set(100)
        bButton:EnableHitTest(true)
        bButton:Show()
        Tooltip.AddButtonTooltip(bButton,'BuffAIs',2)
    end
end
